﻿namespace ULtraChartDoughnutChartSpecialLabel
{
    using System;
    using System.Data;
    using System.Drawing;
    using System.Linq;
    using System.Windows.Forms;
    using Infragistics.UltraChart.Core.Primitives;
    using Infragistics.UltraChart.Shared.Events;
    using Infragistics.UltraChart.Shared.Styles;
    using Infragistics.Win.UltraWinChart;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.ultraChart1.FillSceneGraph += UltraChart1_FillSceneGraph;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.SetupChart(this.ultraChart1);
        }

        private void UltraChart1_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
        {
            var chart = sender as UltraChart;
            if(chart == null)
                return;

            foreach(var item in e.SceneGraph)
            {
                var wedge = item as Wedge;
                if(wedge != null)
                {
                    Text text = new Text();

                    var sum = this.GetSum(chart);
                    text.SetTextString(sum);

                    text.labelStyle.Font = new Font(this.Font.Name, 15);

                    var textSize = Size.Empty;
                    using(Graphics g = chart.CreateGraphics())
                    {
                        textSize = g.MeasureString(sum, text.labelStyle.Font).ToSize();
                    }

                    var location = new Point(wedge.Center.X - textSize.Width / 2, wedge.Center.Y - textSize.Height / 2);
                    text.bounds = new Rectangle(location, textSize);
                    e.SceneGraph.Add(text);
                    break;
                }
            }
        }

        private string GetSum(UltraChart chart)
        {
            var data = chart.DataSource as DataTable;
            return data.AsEnumerable().Sum(x => (int)x[1]).ToString();
        }

        private void SetupChart(UltraChart chart)
        {
            var data = new DataTable();

            data.Columns.Add("Product");
            data.Columns.Add("Units Sold", typeof(int));

            data.Rows.Add(new object[] { "Java", 225 });
            data.Rows.Add(new object[] { "ActiveX", 653 });
            data.Rows.Add(new object[] { ".NET", 335 });
            data.Rows.Add(new object[] { "Misc", 132 });
            data.Rows.Add(new object[] { "Native", 56 });
            data.Rows.Add(new object[] { "Apple", 62 });

            chart.ChartType = ChartType.DoughnutChart;
            chart.DataSource = data;
        }
    }
}
